#include <cstdio>
#include <vector>
#include <map>
#include <algorithm>
#include <list>
using namespace std;
#define FORE(i,c) for(__typeof((c).begin())i=(c).begin();i!=(c).end();++i)

const int memory_size = 1024*128/5;
const int FIRST=0, NEXT=1, BEST=2, WORST=3,
          NOSORT=0, SIZE=1, ADDRESS=2,
	  INNER=0, MULTIPLE=1;

struct block {
   int size;
   int pos;
   block(int size=0, int pos=0) : size(size), pos(pos) { }
};

int strategy, sorting, fragmentation, fragment_factor;

list<block> freeb;
list<block>::iterator it;

map<int,block> full;
int who, size, indx, errors;
int allocated, free_mem;

int main() {
   scanf("%d%d%d%d",
	 &strategy, &sorting, &fragmentation, &fragment_factor);

   printf("# index 0 time errors-num ilosc-blokow-wolnych przydzielonych zajetosc-pamieci\n");

   freeb.push_back(block(memory_size,0));
   it = freeb.begin();
   
   
   free_mem = memory_size;
   while (scanf("%d %d",&who,&size),who) {
      if (size) { /*alloc*/


	 if (fragmentation == MULTIPLE) size = (size+fragment_factor-1)/fragment_factor*fragment_factor;

	 list<block>::iterator found = freeb.end();
	 int j = 0;
	 
	 if (strategy != NEXT) it = freeb.begin();
	 if (strategy == FIRST || strategy == NEXT) {
	    list<block>::iterator start_it = it;
	    for (; it != freeb.end() && found == freeb.end(); ++it, ++j)
	       if (it->size >= size) found = it;
	    for (it = freeb.begin(); it != start_it && found == freeb.end(); ++it, ++j)
	       if (it->size >= size) found = it;
	 } else if (strategy == BEST) {
	    int best_size = memory_size + 1;
	    for (; it != freeb.end(); ++it, ++j)
	       if (it->size >= size && it->size < best_size) { found = it; best_size = it->size; }
	 } else if (strategy == WORST) {
	    int best_size = -1;
	    for (; it != freeb.end(); ++it, ++j)
	       if (it->size >= size && it->size > best_size) { found = it; best_size = it->size; }
	 }
	 
	 if (found != freeb.end()) {
	    full[who] = block(size, found->pos); found->pos += size; found->size -= size;

	    if (found->size == 0) it = found = freeb.erase(found);
	    else if (fragmentation == INNER && found->size <= fragment_factor) {
	       full[who].size += found->size; it = found = freeb.erase(found);
	    }
	    ++allocated;
	    free_mem -= full[who].size;
	 }
	 errors += found == freeb.end(); /* tu jest blad w programie. nalezy ta linijke przesunac PRZED powyzszego if'a */
	 printf("%d 0 %d %d %d %d %d\n",indx++,j,errors, freeb.size(), allocated, 100*(memory_size-free_mem)/memory_size);
      } else if (full.find(who) != full.end()) { /*free*/
	 free_mem += full[who].size;
	 FORE(i,freeb) if (i->pos + i->size == full[who].pos) { full[who].pos = i->pos; full[who].size += i->size;
	    freeb.erase(i); break; }
	 FORE(i,freeb) if (full[who].pos + full[who].size == i->pos) { full[who].size += i->size;
	    freeb.erase(i); break; }
	 if (sorting == NOSORT) freeb.push_back(full[who]);
	 else if (sorting == SIZE) {
	    for (list<block>::iterator i = freeb.begin(); ; ++i)
	       if (i == freeb.end() || i->size <= full[who].size) { freeb.insert(i, full[who]); break; }
	 }
	 else if (sorting == ADDRESS) {
	    for (list<block>::iterator i = freeb.begin(); ; ++i)
	       if (i == freeb.end() || i->pos > full[who].pos) { freeb.insert(i, full[who]); break; }
	 }
	 it = freeb.begin();
	 --allocated;
      }
   }
   return 0;
}

